#include "storypresent.h"
#include "dag_layout.h"
#include "xast_parse.h"
#include "dag_present.h"
#include "view_present.h"
#include <argsparser.h>
#include <QDebug>
#include <QMessageBox>
#include <QTextEdit>
#include <QtWidgets/QApplication>


using namespace args_parse;
using namespace std;


int main(int argc, char* argv[]) {
	QApplication a(argc, argv);

	ArgsParser cmdrec;
	auto help_mode = std::make_shared<MatchMode>(0x000au, u8"ӡĵ");
	cmdrec << help_mode;
	(*help_mode) << std::make_shared<IndexParam>(u8"StoryPresent", u8"") << make_shared<FloatOption>(u8"help", u8"ӡĵ");

	auto test_mode = std::make_shared<MatchMode>(0x000bu, u8"ڲ");
	cmdrec << test_mode;
	(*test_mode) << std::make_shared<IndexParam>(u8"StoryPresent", u8"") << make_shared<FloatOption>(u8"test", u8"ӡĵ");

	auto rst = cmdrec.parse(argc, argv);
	QTextEdit msg;
	msg.setReadOnly(true);
	if (!rst) {
		msg.setWindowTitle(u8"");
		msg.setPlainText(cmdrec.helperDoc());
		msg.show();
	}
	else {
		switch (rst->modeCode()) {
		case 0x000au:
			msg.setWindowTitle(u8"Ϣ");
			msg.setPlainText(cmdrec.helperDoc());
			msg.show();
			break;

		case 0x000bu:
			{
				auto arrows = QList<graph_data::Arrow>() <<
					graph_data::Arrow(u8"aĲ", u8"bĲ") <<
					graph_data::Arrow(u8"cĲ", u8"bĲ") <<
					graph_data::Arrow(u8"cĲ", u8"dĲ") <<
					graph_data::Arrow(u8"bĲ", u8"eĲ") <<
					graph_data::Arrow(u8"dĲ", u8"eĲ") <<
					graph_data::Arrow(u8"cĲ", u8"eĲ");
				auto view = new dags::DAGActiveView;
				view->updateWithEdges(arrows);
				view->show();

				//dags::DAGGraph tools;
				//tools.rebuildFromEdges(arrows);
				//tools.graphLayout();

				//for (auto n : tools.nodeWithLayout()) {
				//	msg.setWindowTitle("layout-message");
				//	msg.append(QString("node:%3,layer:%1,sort:%2").arg(n->layerNumber()).arg(n->sortNumber()).arg(n->layerNode()->bindPoint().name()));
				//	msg.show();
				//}
			}break;
		default:
			break;
		}
	}

	return a.exec();
}
